from Server import Server

class PdServer(Server):
	def __init__(self, *args, **kwargs):
		Server.__init__(self, *args, **kwargs)
		self.numchans = 0
		self.IDs = {} 
	
	def Connected(self, channel, addr):
		print "Connection from", addr, channel
	
	def MakeNewID(self, what):
		ID = 1
		IDs = self.IDs.keys()
		while ID in IDs:
			ID += 1
		self.IDs[ID] = what
		return ID
	
	def Pump(self):
		Server.Pump(self)
		if self.numchans != len(self.channels):
			print len(self.channels), "channels"
			self.numchans = len(self.channels)
		# pump the outgoing sockets of channels
		for c in self.channels:
			c.Pump()
	
	def FromClient(self, source, data):
		print source, data
		for c in self.channels:
			c.ToClient([source] + data)
	
	def Remove(self, channel):
		del self.IDs[channel.id]
		Server.Remove(self, channel)
